diff --git a/doc/guides/rel_notes/release_20_02.rst b/doc/guides/rel_notes/release_20_02.rst
index dfebc46..8a493e4 100644
--- a/doc/guides/rel_notes/release_20_02.rst
+++ b/doc/guides/rel_notes/release_20_02.rst
@@ -74,7 +74,7 @@ New Features
   Added the new ``ionic`` net driver for Pensando Ethernet Network Adapters.
   See the :doc:`../nics/ionic` NIC guide for more details on this new driver.
 
-* **Updated Broadcom bnxt driver**
+* **Updated Broadcom bnxt driver.**
 
   Updated Broadcom bnxt driver with new features and improvements, including:
 
@@ -91,10 +91,10 @@ New Features
 
   Updated the Intel ice driver with new features and improvements, including:
 
-  * Added support for MAC rules on specific port.
+  * Added support for MAC rules on a specific port.
   * Added support for MAC/VLAN with TCP/UDP in switch rule.
   * Added support for 1/10G device.
-  * Added support for API rte_eth_tx_done_cleanup.
+  * Added support for API ``rte_eth_tx_done_cleanup``.
 
 * **Updated Intel iavf driver.**
 
@@ -105,7 +105,9 @@ New Features
 
 * **Updated the Intel ixgbe driver.**
 
-  * Added support for API rte_eth_tx_done_cleanup.
+  Updated ixgbe PMD with new features and improvements, including:
+
+  * Added support for API ``rte_eth_tx_done_cleanup()``.
   * Added support setting VF MAC address by PF driver.
   * Added support for setting the link to specific speed.
 
@@ -122,7 +124,7 @@ New Features
   * Extended PHY access AQ cmd.
   * Added support for reading LPI counters.
   * Added support for Energy Efficient Ethernet.
-  * Added support for API rte_eth_tx_done_cleanup.
+  * Added support for API ``rte_eth_tx_done_cleanup()``.
   * Added support for VF multiple queues interrupt.
   * Added support for setting the link to specific speed.
 
@@ -135,7 +137,7 @@ New Features
   * Removed limitation of matching on tagged/untagged packets (when using DV flow engine).
   * Added BlueField-2 integrated ConnectX-6 Dx device support.
 
-* **Add new vDPA PMD based on Mellanox devices**
+* **Add new vDPA PMD based on Mellanox devices.**
 
   Added a new Mellanox vDPA  (``mlx5_vdpa``) PMD.
   See the :doc:`../vdpadevs/mlx5` guide for more details on this driver.
@@ -155,6 +157,8 @@ New Features
 
 * **Added algorithms to cryptodev API.**
 
+  Added new algorithms to the cryptodev API:
+
   * ECDSA (Elliptic Curve Digital Signature Algorithm) is added to
     asymmetric crypto library specifications.
   * ECPM (Elliptic Curve Point Multiplication) is added to
@@ -162,8 +166,8 @@ New Features
 
 * **Added synchronous Crypto burst API.**
 
-  A new API is introduced in crypto library to handle synchronous cryptographic
-  operations allowing to achieve performance gain for cryptodevs which use
+  A new API has been introduced in the crypto library to handle synchronous cryptographic
+  operations allowing it to achieve performance gains for cryptodevs which use
   CPU based acceleration, such as Intel AES-NI. An implementation for aesni_gcm
   cryptodev is provided. The IPsec example application and ipsec library itself
   were changed to allow utilization of this new feature.
@@ -174,7 +178,7 @@ New Features
   (generation) and cipher-hash (verification) requests (e.g. SNOW3G + ZUC or
   ZUC + AES CTR) in QAT PMD possible when running on GEN3 QAT hardware.
   Such algorithm combinations are not supported on GEN1/GEN2 hardware
-  and executing the request returns RTE_CRYPTO_OP_STATUS_INVALID_SESSION.
+  and executing the request returns ``RTE_CRYPTO_OP_STATUS_INVALID_SESSION``.
 
 * **Queue-pairs are now thread-safe on Intel QuickAssist Technology (QAT) PMD.**
 
@@ -185,34 +189,35 @@ New Features
 
 * **Updated the ZUC PMD.**
 
-  * Transistioned underlying library from libSSO ZUC to intel-ipsec-mb
+  * Transitioned underlying library from libSSO ZUC to intel-ipsec-mb
     library (minimum version required 0.53).
   * Removed dynamic library limitation, so PMD can be built as a shared
     object now.
 
 * **Updated the KASUMI PMD.**
 
-  * Transistioned underlying library from libSSO KASUMI to intel-ipsec-mb
+  * Transitioned underlying library from libSSO KASUMI to intel-ipsec-mb
     library (minimum version required 0.53).
 
 * **Updated the SNOW3G PMD.**
 
-  * Transistioned underlying library from libSSO SNOW3G to intel-ipsec-mb
+  * Transitioned underlying library from libSSO SNOW3G to intel-ipsec-mb
     library (minimum version required 0.53).
 
 * **Changed armv8 crypto PMD external dependency.**
 
-  armv8 crypto PMD now depends on Arm crypto library, and Marvell's
-  armv8 crypto library is not used anymore. Library name is changed
+  Changed armv8 crypto PMD external dependency. The
+  armv8 crypto PMD now depends on the Arm crypto library, and Marvell's
+  armv8 crypto library is not used anymore. The library name has been changed
   from armv8_crypto to AArch64crypto.
 
 * **Added inline IPsec support to Marvell OCTEON TX2 PMD.**
 
-  Added inline IPsec support to Marvell OCTEON TX2 PMD. With the feature,
-  applications would be able to offload entire IPsec offload to the hardware.
+  Added inline IPsec support to Marvell OCTEON TX2 PMD. With this feature,
+  applications will be able to offload entire IPsec offload to the hardware.
   For the configured sessions, hardware will do the lookup and perform
-  decryption and IPsec transformation. For the outbound path, application
-  can submit a plain packet to the PMD, and it would be sent out on wire
+  decryption and IPsec transformation. For the outbound path, applications
+  can submit a plain packet to the PMD, and it will be sent out on the wire
   after doing encryption and IPsec transformation of the packet.
 
 * **Added Marvell OCTEON TX2 End Point rawdev PMD.**
@@ -222,7 +227,7 @@ New Features
 
 * **Added event mode to l3fwd sample application.**
 
-  Add event device support for ``l3fwd`` sample application. It demonstrates
+  Added event device support for the ``l3fwd`` sample application. It demonstrates
   usage of poll and event mode IO mechanism under a single application.
 
 * **Added cycle-count mode to the compression performance tool.**
@@ -232,8 +237,8 @@ New Features
 
 * **Added OpenWrt howto guide.**
 
-  Added document describes how to enable DPDK on OpenWrt in both virtual and
-  physical machine.
+  Added document which describes how to enable DPDK on OpenWrt in both virtual and
+  physical machines.
 
 
 Removed Items
@@ -250,7 +255,7 @@ Removed Items
 
 * **Disabled building all the Linux kernel modules by default.**
 
-  In order to remove the build time dependency with Linux kernel,
+  In order to remove the build time dependency on the Linux kernel,
   the Technical Board decided to disable all the kernel modules
   by default from 20.02 version.
 
@@ -259,8 +264,8 @@ Removed Items
   The internal tail write coalescing feature was removed as not compatible with
   dual-thread feature. It was replaced with a threshold feature. At busy times
   if only a small number of packets can be enqueued, each enqueue causes
-  an expensive MMIO write. These MMIO write occurrences can be optimised by using
-  the new threshold parameter on process start. Please see qat documentation for
+  an expensive MMIO write. These MMIO write occurrences can be optimized by using
+  the new threshold parameter on process start. Please see QAT documentation for
   more details.
 
 
@@ -279,6 +284,8 @@ API Changes
    Also, make sure to start the actual text at the margin.
    =========================================================
 
+* No changes in this release.
+
 
 ABI Changes
 -----------
@@ -298,21 +305,6 @@ ABI Changes
 * No change, kept ABI v20. DPDK 20.02 is compatible with DPDK 19.11.
 
 
-Known Issues
-------------
-
-.. This section should contain new known issues in this release. Sample format:
-
-   * **Add title in present tense with full stop.**
-
-     Add a short 1-2 sentence description of the known issue
-     in the present tense. Add information on any known workarounds.
-
-   This section is a comment. Do not overwrite or remove it.
-   Also, make sure to start the actual text at the margin.
-   =========================================================
-
-
 Tested Platforms
 ----------------
 